% EJERCICIO 8-1
clc;
clear all;
close all;
A=[0 1; 0 -1];
B=[0; 10];
C=[1 0];
D=[0];
Ts=0.1
disp(' Modelo de Estado Continuo');
disp(' ')
P1=ss(A,B,C,D)
pause;
clc;
disp(' Modelo de Estado Discreto');
disp(' ')
P2=c2d(P1,Ts,'zoh')
pause;
U=ctrb(P2)
rank(U)
V=obsv(P2)
rank(V)
Psi=.46;
Tau=0.5;  % seg
Wn=1/Psi/Tau
Polos=[exp(-Psi*Wn+i*Wn*(1-Psi^2)^.5)*Ts exp(-Psi*Wn-i*Wn*(1-Psi^2)^.5)*Ts]
G1=tf([Wn^2],[1 2*Psi*Wn Wn^2])
[Z,P,K]=zpkdata(G1,'v')
G2=c2d(G1,Ts,'zoh')
[Z,P,K]=zpkdata(G2,'v')
% VECTOR DE REALIMENTACION
Kt=acker(P2.a,P2.b,P)
% MODELO DE LAZO CERRADO
P3=P2;
P3.a=P2.a-P2.b*Kt;
P3
% TRANSFERENCIA
G3=tf(P3)
step(P3)

[num,den]=tfdata(P2,'v');
Ac=[0,1;-den(3),-den(2)];
Bc=[0;1];
Cc=[num(3),num(2)];
Dc=0;
%modelo canonico
clc;
str1=sprintf('\n Modelo Canonico Observable \n');
disp(str1);
P4=transpose(ss(Ac,Bc,Cc,Dc,0.01))
str1=sprintf('\n Matriz Observabilidad de la Planta Original \n');
disp(str1);
V1=obsv(P2)
str1=sprintf('\n Matriz Observabilidad del Modelo Canonico \n');
disp(str1);
V2=obsv(P4)
str1=sprintf('\n Matriz Transformacion al Modelo Canonico \n');
disp(str1);
Q=inv(V1)*V2
P5=ss2ss(P2,inv(Q));
disp('autovalores del Estimador')

z1=0.67
z2=0.67

%z1=input('autovalor del estimador z1 = ')

%z2=input('autovalor del estimador z2 = ')

str1=sprintf('\n Vector del Estimador del Modelo Canonico \n');
disp(str1);
H1=acker(Ac,Bc,[z1,z2])'

str1=sprintf('\n Vector del Estimador transformado \n');
disp(str1);
H2=Q*H1

pause

%H3=acker(P2.a',P2.c',z1)'
%Matriz de Error del Estimador

Ae=(P2.a-H2*P2.c)
eig(Ae)
He=H2*P2.c
Be=[0;0]
Ce=eye(2)

Xe0=[10,10];
close all;
% Modelo del Error
str1=sprintf('\n Modelo del error \n');
disp(str1);
Pe=ss(Ae,Be,Ce,Be,.1)
initial(Pe,Xe0,2);
eig(Ae);
pause
clc
close all
At=[P2.a -P2.b*Kt; H2*P2.c P2.a-H2*P2.c-P2.b*Kt]
Bt=[P2.b;P2.b]
Ct=eye(4)
Dt=[0;0;0;0]
P5=ss(At,Bt,Ct,Dt,.1)
X0=[5;5;0;0]
[U,T]=gensig('square',20,2,.1);
U=10-U
Y=lsim(P5,U,T,X0)
plot(T,Y(:,1))
hold on
plot(T,Y(:,3),'r')
title( 'RESPUESTA DE X1 Y X1 ESTIMADA')
figure(2)
plot(T,Y(:,2))
hold on
plot(T,Y(:,4),'r')
title( 'RESPUESTA DE X2 Y X2 ESTIMADA')